// -*- Java -*-
/*!
 * @file  JFrameComponentImpl.java
 * @brief JFrame Component
 * @date  $Date$
 *
 * $Id$
 */


import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JFrame;

import jp.go.aist.rtm.RTC.DataFlowComponentBase;
import jp.go.aist.rtm.RTC.Manager;
import jp.go.aist.rtm.RTC.port.InPort;
import jp.go.aist.rtm.RTC.port.OutPort;
import jp.go.aist.rtm.RTC.util.DataRef;
import RTC.ReturnCode_t;
import RTC.TimedLong;


/**
 * GUINX
 * @author ysuga
 *
 */
class MyFrame extends JFrame {
	private boolean buttonPushed;
	private int value;
	
	
	/**
	 * RXgN^
	 * @param value GUIʂ̒l
	 */
	public MyFrame(int value) {
		super(Integer.toString(value));
		
		this.value = value;
		
		JButton button = new JButton(new MyAction("Push"));
		
		getContentPane().add(button);
		setSize(400,300);
		setVisible(true);
		
	}
	
	/**
	 * {^ꂽANV
	 * @author ysuga
	 *
	 */
	class MyAction extends AbstractAction {
		public MyAction(String txt) {
			super(txt);
		}
		
		public void actionPerformed(ActionEvent e) {
			// button pushed.
			buttonPushed = true;
		}
	}
	
	/**
	 * {^ꂽ̃tO擾D
	 * ꂪĂ΂ƃtO͉D
	 * @return
	 */
	public boolean isButtonPushed() {
		boolean flag = buttonPushed;
		buttonPushed = false;
		return flag;
	}
	
	/**
	 * GUIʂ̒l̓ǂݎD
	 * @return
	 */
	public int getValue() {
		return value;
	}

}
/*!
 * @class JFrameComponentImpl
 * @brief JFrame Component
 *
 */
public class JFrameComponentImpl extends DataFlowComponentBase {

	MyFrame myFrame;
  /*!
   * @brief constructor
   * @param manager Maneger Object
   */
	public JFrameComponentImpl(Manager manager) {  
        super(manager);
        // <rtc-template block="initializer">
        m_in_val = new TimedLong();
        m_in = new DataRef<TimedLong>(m_in_val);
        m_inIn = new InPort<TimedLong>("in", m_in);
        m_out_val = new TimedLong();
        m_out = new DataRef<TimedLong>(m_out_val);
        m_outOut = new OutPort<TimedLong>("out", m_out);
        // </rtc-template>

        // Registration: InPort/OutPort/Service
        // <rtc-template block="registration">
        // Set InPort buffers
        try {
			registerInPort(TimedLong.class, "in", m_inIn);
		} catch (Exception e) {
			e.printStackTrace();
		}
        
        // Set OutPort buffer
        try {
			registerOutPort(TimedLong.class, "out", m_outOut);
		} catch (Exception e) {
			e.printStackTrace();
		}
        
        // Set service provider to Ports
        
        // Set service consumers to Ports
        
        // Set CORBA Service Ports
        
        // </rtc-template>
    }

    /***
     *
     * The execution action that is invoked periodically
     * former rtc_active_do()
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
    @Override
    protected ReturnCode_t onExecute(int ec_id) {
    	
    	/**
    	 * ̓f[^ɂGUIςD
    	 */
    	if(m_inIn.isNew()) {
    		m_inIn.read();
   			myFrame = new MyFrame(m_in.v.data);
    	}
    	
    	if(myFrame != null) {
    		if(myFrame.isButtonPushed()) {
    			m_out.v.data = myFrame.getValue();
    			m_outOut.write();
    		}
    	}
    	
        return super.onExecute(ec_id);
    }

 
    // DataInPort declaration
    // <rtc-template block="inport_declare">
    protected TimedLong m_in_val;
    protected DataRef<TimedLong> m_in;
    /*!
     */
    protected InPort<TimedLong> m_inIn;

    
    // </rtc-template>

    // DataOutPort declaration
    // <rtc-template block="outport_declare">
    protected TimedLong m_out_val;
    protected DataRef<TimedLong> m_out;
    /*!
     */
    protected OutPort<TimedLong> m_outOut;

}
